#! /usr/bin/python

import sys
import os
import gadfly

def get_table(cursor, t):
    cursor.execute('select * from %s' % t[0])
    table = []
    for c in cursor.description:
        table.append(c[0])
    table = [tuple(table)]
    table.extend(cursor.fetchall())

    return table

def show_table(cursor, t, fo, prefix):
    table = get_table(cursor, t)
    fo.write(prefix+'<table>\n')

    ## == caption
    align = 'align="center" valign="top"'
    if t[1]:
        fo.write(prefix+'  <caption  "View: %s"  %s />\n' % (t[0], align))
    else:
        fo.write(prefix+'  <caption  "Table: %s" %s />\n' % (t[0], align))

    ## == header
    fo.write(prefix+'  <thead>\n')
    fo.write(prefix+'    <tr>\n')
    fo.write(prefix+'      <th colspan="%i" class="table-title">\n' % len(table[0]))

    if t[1]:
        fo.write(prefix+'        View: %s\n' % t[0])
    else:
        fo.write(prefix+'        Table: %s\n' % t[0])
    fo.write(prefix+'      </th>\n')
    fo.write(prefix+'    </tr>\n')
    fo.write(prefix+'    <tr>\n')
    for td in table[0]:
        fo.write(prefix+'      <th>\n')
        fo.write(prefix+'        %s\n' % td)
        fo.write(prefix+'      </th>\n')
    fo.write(prefix+'    </tr>\n')

    fo.write(prefix+'  </thead>\n')

##    ## == footer
##    fo.write(prefix+'  <tfoot>\n')
##    fo.write(prefix+'    <tr>\n')
##    fo.write(prefix+'      <td>\n')
##    fo.write(prefix+'        Created by mod_python\n')
##    fo.write(prefix+'      </td>\n')
##    fo.write(prefix+'    </tr>\n')
##    fo.write(prefix+'  <tfoot>\n')

    ## == body
    fo.write(prefix+'  <tbody>\n')
    for row in table[1:]:
        fo.write(prefix+'    <tr>\n')
        for td in row:
            fo.write(prefix+'      <td>\n')
            fo.write(prefix+'        %s\n' % td)
            fo.write(prefix+'      </td>\n')
        fo.write(prefix+'    </tr>\n')
##        fo.write(prefix+repr(row)+'\n')
    fo.write(prefix+'  <tbody>\n')

    fo.write(prefix+'</table>\n')

def show_table_list(fo, tables, prefix = ''):
    fo.write(prefix+'<table>\n')

    ## == caption
    align = 'align="center" valign="top"'
    fo.write(prefix+'  <caption  "List of tables" %s />\n' % align)

    ## == header
    fo.write(prefix+'  <thead>\n')
    fo.write(prefix+'    <tr>\n')
    fo.write(prefix+'      <th class="table-title">\n')
    fo.write(prefix+'        List of Tables\n')
    fo.write(prefix+'      </th>\n')
    fo.write(prefix+'    </tr>\n')
    fo.write(prefix+'  </thead>\n')

    ## == body
    fo.write(prefix+'  <tbody>\n')
    fo.write(prefix+'    <tr>\n')
    fo.write(prefix+'      <td>\n')
    fo.write(prefix+'        <ul>\n')
    for t in tables:
        fo.write(prefix+'          <li>%s\n' % t[0])
    fo.write(prefix+'        </ul>\n')
    fo.write(prefix+'      </td>\n')
    fo.write(prefix+'    </tr>\n')
    fo.write(prefix+'  <tbody>\n')
    fo.write(prefix+'</table>\n')
    return

def show_database(fo):
    if hasattr(fo, 'filename'):
        prefix = os.path.dirname(fo.filename)+'/'
    else:
        prefix = ''
    connection = gadfly.gadfly('kickstart_configs', prefix+'databases')

    cursor = connection.cursor()
    cursor.execute('select * from __table_names__')

    tables = []
    for t in cursor.fetchall():
        if t[0][:2] != '__' and t[0] != 'DUAL':
            tables.append(t)

    fo.write('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">\n')
    fo.write('<html>\n')
    fo.write('  <head>\n')
    fo.write('    <title>kickstart_configs database</title>\n')
    fo.write('    <link rel="stylesheet" type="text/css" href="browse-database.css" />\n')
    fo.write('  </head>\n')
    fo.write('  <body>\n')
    fo.write('    <h1>kickstart_configs database</h1>\n')
    fo.write('    <table>\n')
    fo.write('      <tr>\n')
    fo.write('        <td class="major-section">\n')
    show_table_list(fo, tables, '        ')
    fo.write('        </td>\n')
    fo.write('        <td class="major-section">\n')
    for t in tables:
        show_table(cursor, t, fo, '      ')
    fo.write('        </td>\n')
    fo.write('      </tr>\n')
    fo.write('    </table>\n')
    fo.write('    <hr />\n')
    fo.write('  </body>\n')
    fo.write('</html>\n')

def main(fo):
    status = 0

    show_database(fo)

##    cursor.execute('select * from machine')
##    print cursor.pp()

    return status

if __name__ == '__main__':
    sys.exit(main(sys.stdout))
