#! /usr/bin/python

import sys
import os
import gadfly
from machine import Machine, machine_table
from configuration import Configuration, configuration_table

def main(argv):
    status = 0
    
    connection = gadfly.gadfly()
    connection.startup('kickstart_configs', 'databases')
    cursor = connection.cursor()

    tables = [
        machine_table,
        configuration_table
        ]

    for t in tables:
        t.create(cursor)

        ## == If <tn>.dat exists, insert data into the database
        fn = t.name+'.tbl'
        if os.path.isfile(fn):
            fo = open(fn)
            for l in fo.readlines():
                values = l.split(',')
                values = map(''.__class__.strip,values)
                t.insert_list(cursor, values)

    connection.commit()


    return status

if __name__ == '__main__':
    sys.exit(main(sys.argv))
